-- written by groverbuger for g3d
-- may 2021
-- MIT license

local g3d = require "g3d"
local earth = g3d.newModel("assets/box.obj", "assets/level1_walls.png", {4,0,0}, {math.pi/2,0,0}, {1,1,1})
local moon = g3d.newModel("assets/sphere.obj", "assets/moon.png", {0,0,0}, nil, {0.5,0.5,0.5})
local timer = 0
local color = {0,1,0}
local ambientcolor = {1,1,1}

local lightingShader = love.graphics.newShader(g3d.path .. "/g3d.vert", "lighting.frag")

function love.update(dt)
    timer = timer + dt
    moon:setTranslation(math.cos(timer)*2+4 , math.sin(timer)*2, 0)
    moon:setRotation(0, timer - math.pi/2, 0)
    g3d.camera.firstPersonMovement(dt)
    if love.keyboard.isDown "escape" then
        love.event.push "quit"
    end
	lightingShader:send("lightPosition", moon.translation)
	lightingShader:send("lightColor", color)
	lightingShader:send("ambientLightColor", ambientcolor)
	lightingShader:send("ambient", 0.3)
end

function love.draw()
    g3d.camera.updateViewMatrix(lightingShader)
    g3d.camera.updateProjectionMatrix(lightingShader)
    earth:draw(lightingShader)
    moon:draw()
end

function love.mousemoved(x,y, dx,dy)
    g3d.camera.firstPersonLook(dx,dy)
end

